
//+------------------------------------------------------------------+
//|                       Symphonie, Expert Advisor for MetaTrader 4 |
//|                       Copyright  2012, asasa, trapule@gmail.com |
//|              http://www.forexfactory.com/showthread.php?t=315572 |
//+------------------------------------------------------------------+

#property copyright     "Copyright  2012, asasa, trapule@gmail.com"
#property link          "trapule@gmail.com"
#define EA_NAME_VERSION "Symphonie v0.0.6"
#define EA_SHORT_NAME   "SYM"

extern string GeneralDescr               = "General parameters:";
extern int    MagicNumber                = 20111227;
extern int    TimeFrame                  = -1; // -1 means the current timeframe of the chart
extern int    AllowedDir                 = 0; // 1 means LONG, -1 means SHORT, 0 means both
extern int    EvaluationBar              = 1;  // 1- for long br0ker not allowing hedging
extern bool   CheckOnlyAtEndOfBar        = true;
extern bool   FirstBarConfirmation       = true;
extern int    MaxExtremeDist             = 100;
extern int    StartExtremeDist           = 3;
extern double StopLossPips               = 60; // in case position goes wrong way
extern double TakeProfitPips             = 1000;// because will probaby change direction before
extern double FixedLots                  = 0.1; //make more if 100k acct
bool          AllowMultipleOrders        = true;// lets see what happens , 50k in this acct
bool          ProgressiveBarSignals      = true;
extern bool   ExitAtExtreme              = true;// hopefully will close and re-enter if repaints
extern double PipGainForBreakevenStop    = 30.0;// just in case, will resume if all signals lineup again
double        PipLossForBreakevenTarget  = 60;// if ea gets confused by false signals, repaint or br0ker spiking the tick
extern int    MondayHourStart            = 2;
extern bool   UseTmaFilter               = true;// nice one Java James
extern bool   DisplayIndicators          = true;

extern string ExtrDescr                  = "Extreme indicator parameters:";//standard as all are
extern int    ExtrPriceActionFilter      = 1;
extern int    ExtrLength                 = 3;
extern int    ExtrMajorCycleStrength     = 4;
extern int    ExtrUseCycleFilter         = 1;//only this is true and not standard
extern int    ExtrUseFilterSMAorRSI      = 1;
extern int    ExtrFilterStrengthSMA      = 12;
extern int    ExtrFilterStrengthRSI      = 21;
bool          ExtrMinorAlert             = false;// because irritate the crap out of me
bool          ExtrMajorAlert             = false;
bool          ExtrMajorGoneAlert         = false;
bool          ExtrSoundAlert             = false;
bool          ExtrEmailAlert             = false;
extern bool   ExtrTrackMajorCycleHistory = false;
extern bool   ExtrWaitForClose           = false;
extern int    ExtrMajorGoneLookBackBars  = 100;
string        Extrnote1                  = ""; //"alert all = 0, none = 4";
string        Extrnote2                  = ""; //"buy only = 1, sell only = 2";
int           ExtralertsOption           = 4;// very irritating

extern string MarketEmotionDescr         = "Market Emotion indicator parameters:";
extern int    MarketEmotionSSP           = 7;
extern double MarketEmotionKmax          = 50.6;
extern int    MarketEmotionCountBars     = 500;// 3000 is too much i think even for 1M or 4H

extern string SentimentDescr             = "Sentiment indicator parameters:";
extern int    SentimentPeriod            = 12;

extern string TrendlineDescr             = "Trendline indicator parameters:";
extern int    TrendlineCCIPeriod         = 63;
extern int    TrendlineATRPeriod         = 18;

extern string TmaDescr                   = "TMA indicator parameters:";
string        TmaTimeFrame               = "current time frame";
extern int    TmaHalfLength              = 56;
extern int    TmaPrice                   = PRICE_CLOSE; // dont get this one
extern double TmaATRMultiplier           = 2.0;
extern int    TmaATRPeriod               = 100;
extern bool   TmaInterpolate             = true;// dont get this one either
bool          TmaAlertsOn                = false;// more irritating stuff
bool          TmaAlertsOnCurrent         = false;
bool          TmaAlertsOnHighLow         = false;
bool          TmaAlertsMessage           = false;
bool          TmaAlertsSound             = false;// are you mad, ding ding beep beep pow pow!
bool          TmaAlertsEmail             = false;

double pip;
int period;
datetime latestbartimesignal;
datetime timeprev;
datetime lastspiketimeonentry;
string logfilename;
int loghandle;
int tickcount;
int tickstart, tickstop;
int tickstarttot, tickstoptot;
string errmsg;
#define LOG_SEP "---------------------------------------------------"

//+------------------------------------------------------------------+

bool InitLog ()
{
  int OpenMode;
        
  if (IsTesting()) 
    OpenMode = FILE_WRITE | FILE_BIN;
  else 
    OpenMode = FILE_WRITE | FILE_READ | FILE_BIN;
      
  logfilename = EA_SHORT_NAME + "_log_" + Symbol() + "_" +CalcMagicNumber(period)+ ".txt";
  loghandle = FileOpen (logfilename, OpenMode);
    
  if (loghandle == -1)
    return (false);
    
  FileSeek (loghandle, 0, SEEK_END);
  return(true);
}

//--------------------------------------------------------------------

bool DeInitLog ()
{
  FileClose (loghandle);
  return (true);
}

//--------------------------------------------------------------------

bool LogMsg (string Msg)
{
  string OutMsg = "#" + tickcount + ", "
             + TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)
             +", "+Symbol()+", "+Msg+"\r\n";
   
  if (! FileWriteString (loghandle, OutMsg, StringLen(OutMsg)))
     return (false);
    
  FileFlush (loghandle);
  return (true);
}

//--------------------------------------------------------------------

void LogRestartString ()
{
  LogMsg (LOG_SEP);
  LogMsg ("#### " + EA_NAME_VERSION + " restart");
  LogMsg (LOG_SEP);
}

//+------------------------------------------------------------------

void LogAccountData ()
{
  LogMsg ("Account:");
  LogMsg ("  Time current = "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS));
  LogMsg ("  Account company = "+AccountCompany());
  LogMsg ("  Account server = "+AccountServer());
  //LogMsg ("  Account name = "+AccountName());
  //LogMsg ("  Account number = "+AccountNumber());
  LogMsg ("  Account currency = "+AccountCurrency());
  LogMsg ("  Account balance = "+dts(AccountBalance(),2));
  LogMsg ("  Account equity = "+dts(AccountEquity(),2));
  LogMsg ("  Account margin = "+dts(AccountMargin(),2));
  LogMsg ("  Account free margin = "+dts(AccountFreeMargin(),2));
  LogMsg ("  Account leverage = "+AccountLeverage());
  LogMsg ("  Margin calculation mode = "+MarketInfo(Symbol(),MODE_MARGINCALCMODE));
  LogMsg ("  Margin init = "+MarketInfo(Symbol(),MODE_MARGININIT));
  LogMsg ("  Margin maintenance = "+MarketInfo(Symbol(),MODE_MARGINMAINTENANCE));
  LogMsg ("  Margin hedged = "+MarketInfo(Symbol(),MODE_MARGINHEDGED));
  LogMsg ("  Margin required = "+MarketInfo(Symbol(),MODE_MARGINREQUIRED));
  LogMsg ("  Terminal company = "+TerminalCompany());
  LogMsg ("  Terminal name = "+TerminalName());
  LogMsg ("  Terminal path = "+TerminalPath());
  LogMsg ("  Is connected = "+IsConnected());
  LogMsg ("  Is demo = "+IsDemo());
  LogMsg ("  Is dlls allowed = "+IsDllsAllowed());
  LogMsg ("  Is expert enabled = "+IsExpertEnabled());
  LogMsg ("  Is libraries allowed = "+IsLibrariesAllowed());
  LogMsg ("  Is optimization = "+IsOptimization());
  LogMsg ("  Is stopped = "+IsStopped());
  LogMsg ("  Is testing = "+IsTesting());
  LogMsg ("  Is trade allowed = "+IsTradeAllowed());
  LogMsg ("  Is visual mode = "+IsVisualMode());
  LogMsg ("  Uninitialize reason = "+UninitializeReason()+" ("+GetUninitReasonDescription(UninitializeReason())+")");
  LogMsg ("  Symbol = "+Symbol());
  LogMsg ("  Period = "+Period());
  LogMsg ("  Point = "+Point);
  LogMsg ("  Digits = "+Digits);
  LogMsg ("  Spread = "+MarketInfo(Symbol(),MODE_SPREAD));
  LogMsg ("  Stop level = "+MarketInfo(Symbol(),MODE_STOPLEVEL));
  LogMsg ("  Lot size = "+MarketInfo(Symbol(),MODE_LOTSIZE));
  LogMsg ("  Tick value = "+MarketInfo(Symbol(),MODE_TICKVALUE));
  LogMsg ("  Tick size = "+MarketInfo(Symbol(),MODE_TICKSIZE));
  LogMsg ("  Min lot = "+MarketInfo(Symbol(),MODE_MINLOT));
  LogMsg ("  Max lot = "+MarketInfo(Symbol(),MODE_MAXLOT));
  LogMsg ("  Lot step = "+MarketInfo(Symbol(),MODE_LOTSTEP));
  LogMsg ("  Margin required = "+MarketInfo(Symbol(),MODE_MARGINREQUIRED));
  LogMsg ("  Freeze level = "+MarketInfo(Symbol(),MODE_FREEZELEVEL));
  LogMsg ("  Swap long = "+MarketInfo(Symbol(),MODE_SWAPLONG));
  LogMsg ("  Swap short = "+MarketInfo(Symbol(),MODE_SWAPSHORT));
  LogMsg ("  Swap type = "+MarketInfo(Symbol(),MODE_SWAPTYPE));
  LogMsg ("  Profit calculation mode = "+MarketInfo(Symbol(),MODE_PROFITCALCMODE));
  LogMsg ("  Margin calculation mode = "+MarketInfo(Symbol(),MODE_MARGINCALCMODE));
  LogMsg ("  Global variables total = "+GlobalVariablesTotal());
  LogMsg ("  Window expert name = "+WindowExpertName());
  LogMsg ("  Objects total = "+ObjectsTotal());
  LogMsg ("  Bars on M1 = "+iBars(Symbol(),PERIOD_M1));
  LogMsg ("  Bars on M5 = "+iBars(Symbol(),PERIOD_M5));
  LogMsg ("  Bars on M15 = "+iBars(Symbol(),PERIOD_M15));
  LogMsg ("  Bars on M30 = "+iBars(Symbol(),PERIOD_M30));
  LogMsg ("  Bars on H1 = "+iBars(Symbol(),PERIOD_H1));
  LogMsg ("  Bars on H4 = "+iBars(Symbol(),PERIOD_H4));
  LogMsg ("  Bars on D1 = "+iBars(Symbol(),PERIOD_D1));
  LogMsg ("  Bars on W1 = "+iBars(Symbol(),PERIOD_W1));
  LogMsg ("  Bars on MN1 = "+iBars(Symbol(),PERIOD_MN1));
}

//--------------------------------------------------------------------

bool LogExternalParams()
{
   LogMsg ("External parameters:");
   LogMsg ("  MagicNumber = "+MagicNumber);
   LogMsg ("  TimeFrame = "+TimeFrame);
   LogMsg ("  AllowedDir = "+AllowedDir);
   LogMsg ("  EvaluationBar = "+EvaluationBar);
   LogMsg ("  CheckOnlyAtEndOfBar = "+CheckOnlyAtEndOfBar);
   LogMsg ("  FirstBarConfirmation = "+FirstBarConfirmation);
   LogMsg ("  MaxExtremeDist = "+MaxExtremeDist);
   LogMsg ("  StartExtremeDist = "+StartExtremeDist);
   LogMsg ("  StopLossPips = "+StopLossPips);
   LogMsg ("  TakeProfitPips = "+TakeProfitPips);
   LogMsg ("  FixedLots = "+FixedLots);
   LogMsg ("  AllowMultipleOrders = "+AllowMultipleOrders);
   LogMsg ("  ProgressiveBarSignals = "+ProgressiveBarSignals);
   LogMsg ("  ExitAtExtreme = "+ExitAtExtreme);
   LogMsg ("  PipGainForBreakevenStop = "+PipGainForBreakevenStop);
   LogMsg ("  PipLossForBreakevenTarget = "+PipLossForBreakevenTarget);
   LogMsg ("  MondayHourStart = "+MondayHourStart);
   LogMsg ("  UseTmaFilter = "+UseTmaFilter);
   LogMsg ("  DisplayIndicators = "+DisplayIndicators);
   LogMsg ("  ExtrPriceActionFilter = "+ExtrPriceActionFilter);
   LogMsg ("  ExtrLength = "+ExtrLength);
   LogMsg ("  ExtrMajorCycleStrength = "+ExtrMajorCycleStrength);
   LogMsg ("  ExtrUseCycleFilter = "+ExtrUseCycleFilter);
   LogMsg ("  ExtrUseFilterSMAorRSI = "+ExtrUseFilterSMAorRSI);
   LogMsg ("  ExtrFilterStrengthSMA = "+ExtrFilterStrengthSMA);
   LogMsg ("  ExtrFilterStrengthRSI = "+ExtrFilterStrengthRSI);
   LogMsg ("  ExtrMinorAlert = "+ExtrMinorAlert);
   LogMsg ("  ExtrMajorAlert = "+ExtrMajorAlert);
   LogMsg ("  ExtrMajorGoneAlert = "+ExtrMajorGoneAlert);
   LogMsg ("  ExtrSoundAlert = "+ExtrSoundAlert);
   LogMsg ("  ExtrEmailAlert = "+ExtrEmailAlert);
   LogMsg ("  ExtrTrackMajorCycleHistory = "+ExtrTrackMajorCycleHistory);
   LogMsg ("  ExtrWaitForClose = "+ExtrWaitForClose);
   LogMsg ("  ExtrMajorGoneLookBackBars = "+ExtrMajorGoneLookBackBars);
   LogMsg ("  ExtralertsOption = "+ExtralertsOption);
   LogMsg ("  MarketEmotionSSP = "+MarketEmotionSSP);
   LogMsg ("  MarketEmotionKmax = "+MarketEmotionKmax);
   LogMsg ("  MarketEmotionCountBars = "+MarketEmotionCountBars);
   LogMsg ("  SentimentPeriod = "+SentimentPeriod);
   LogMsg ("  TrendlineCCIPeriod = "+TrendlineCCIPeriod);
   LogMsg ("  TrendlineATRPeriod = "+TrendlineATRPeriod);
   LogMsg ("  TmaTimeFrame = "+TmaTimeFrame);
   LogMsg ("  TmaHalfLength = "+TmaHalfLength);
   LogMsg ("  TmaPrice = "+TmaPrice);
   LogMsg ("  TmaATRMultiplier = "+TmaATRMultiplier);
   LogMsg ("  TmaATRPeriod = "+TmaATRPeriod);
   LogMsg ("  TmaInterpolate = "+TmaInterpolate);
   LogMsg ("  TmaAlertsOn = "+TmaAlertsOn);
   LogMsg ("  TmaAlertsOnCurrent = "+TmaAlertsOnCurrent);
   LogMsg ("  TmaAlertsOnHighLow = "+TmaAlertsOnHighLow);
   LogMsg ("  TmaAlertsMessage = "+TmaAlertsMessage);
   LogMsg ("  TmaAlertsSound = "+TmaAlertsSound);
   LogMsg ("  TmaAlertsEmail = "+TmaAlertsEmail);

   return (true);
}

//--------------------------------------------------------------------

bool PrintInitComment ()
{
   string comm = EA_NAME_VERSION + "\n";
   comm = comm + "Waiting for start...\n";
   Comment(comm);  
   return (true);
}

//--------------------------------------------------------------------

void WriteDeInitToLog ()
{
  int DeInitReason = UninitializeReason();
  LogMsg (LOG_SEP);
  LogMsg ("#### " + EA_NAME_VERSION + " deinit");
  LogMsg ("Reason "+DeInitReason+" ("+GetUninitReasonDescription(DeInitReason)+")");
}

//--------------------------------------------------------------------

string OrderString (double Lots, double Price, double StopLoss, double TakeProfit)
{
  string StringVal = "lots "+dts(Lots,2)+", price "+dtsp(Price)+", sl "+dtsp(StopLoss)+", tp "+dtsp(TakeProfit)+" (bid "+dtsp(Bid)+", ask "+dtsp(Ask)+")"; 
  return (StringVal);
}

//--------------------------------------------------------------------

string OrderStringTicket (int Ticket)
{
  string StringVal;
  
  if (! OrderSelect (Ticket, SELECT_BY_TICKET))
    StringVal = "-";
  else
    StringVal = "profit "+dts(OrderProfit(),2)+", swap "+dts(OrderSwap(),2)+", lots "+dts(OrderLots(),2)+", price "+dtsp(OrderOpenPrice())+", sl "+dtsp(OrderStopLoss())+", tp "+dtsp(OrderTakeProfit())+" (bid "+dtsp(Bid)+", ask "+dtsp(Ask)+")"; 
  
  return (StringVal);
}

//--------------------------------------------------------------------

string GetErrorCodeDescription (int ErrorCode)
{
  if (ErrorCode == 0) return ("No error returned");
  if (ErrorCode == 1) return ("No error returned, but the result is unknown");
  if (ErrorCode == 2) return ("Common error");
  if (ErrorCode == 3) return ("Invalid trade parameters");
  if (ErrorCode == 4) return ("Trade server is busy");
  if (ErrorCode == 5) return ("Old version of the client terminal");
  if (ErrorCode == 6) return ("No connection with trade server");
  if (ErrorCode == 7) return ("Not enough rights");
  if (ErrorCode == 8) return ("Too frequent requests");
  if (ErrorCode == 9) return ("Malfunctional trade operation");
  if (ErrorCode == 64) return ("Account disabled");
  if (ErrorCode == 65) return ("Invalid account");
  if (ErrorCode == 128) return ("Trade timeout");
  if (ErrorCode == 129) return ("Invalid price");
  if (ErrorCode == 130) return ("Invalid stops");
  if (ErrorCode == 131) return ("Invalid trade volume");
  if (ErrorCode == 132) return ("Market is closed");
  if (ErrorCode == 133) return ("Trade is disabled");
  if (ErrorCode == 134) return ("Not enough money");
  if (ErrorCode == 135) return ("Price changed");
  if (ErrorCode == 136) return ("Off quotes");
  if (ErrorCode == 137) return ("Broker is busy");
  if (ErrorCode == 138) return ("Requote");
  if (ErrorCode == 139) return ("Order is locked");
  if (ErrorCode == 140) return ("Long positions only allowed");
  if (ErrorCode == 141) return ("Too many requests");
  if (ErrorCode == 145) return ("Modification denied because order too close to market");
  if (ErrorCode == 146) return ("Trade context is busy");
  if (ErrorCode == 147) return ("Expirations are denied by broker");
  if (ErrorCode == 148) return ("The amount of open and pending orders has reached the limit set by the broker");
  if (ErrorCode == 149) return ("An attempt to open a position opposite to the existing one when hedging is disabled");
  if (ErrorCode == 150) return ("An attempt to close a position contravening the FIFO rule");
  if (ErrorCode == 4000) return ("No error");
  if (ErrorCode == 4001) return ("Wrong function pointer");
  if (ErrorCode == 4002) return ("Array index is out of range");
  if (ErrorCode == 4003) return ("No memory for function call stack");
  if (ErrorCode == 4004) return ("Recursive stack overflow");
  if (ErrorCode == 4005) return ("Not enough stack for parameter");
  if (ErrorCode == 4006) return ("No memory for parameter string");
  if (ErrorCode == 4007) return ("No memory for temp string");
  if (ErrorCode == 4008) return ("Not initialized string");
  if (ErrorCode == 4009) return ("Not initialized string in array");
  if (ErrorCode == 4010) return ("No memory for array string");
  if (ErrorCode == 4011) return ("Too long string");
  if (ErrorCode == 4012) return ("Remainder from zero divide");
  if (ErrorCode == 4013) return ("Zero divide");
  if (ErrorCode == 4014) return ("Unknown command");
  if (ErrorCode == 4015) return ("Wrong jump (never generated error)");
  if (ErrorCode == 4016) return ("Not initialized array");
  if (ErrorCode == 4017) return ("DLL calls are not allowed");
  if (ErrorCode == 4018) return ("Cannot load library");
  if (ErrorCode == 4019) return ("Cannot call function");
  if (ErrorCode == 4020) return ("Expert function calls are not allowed");
  if (ErrorCode == 4021) return ("Not enough memory for temp string returned from function");
  if (ErrorCode == 4022) return ("System is busy (never generated error)");
  if (ErrorCode == 4050) return ("Invalid function parameters count");
  if (ErrorCode == 4051) return ("Invalid function parameter value");
  if (ErrorCode == 4052) return ("String function internal error");
  if (ErrorCode == 4053) return ("Some array error");
  if (ErrorCode == 4054) return ("Incorrect series array using");
  if (ErrorCode == 4055) return ("Custom indicator error");
  if (ErrorCode == 4056) return ("Arrays are incompatible");
  if (ErrorCode == 4057) return ("Global variables processing error");
  if (ErrorCode == 4058) return ("Global variable not found");
  if (ErrorCode == 4059) return ("Function is not allowed in testing mode");
  if (ErrorCode == 4060) return ("Function is not confirmed");
  if (ErrorCode == 4061) return ("Send mail error");
  if (ErrorCode == 4062) return ("String parameter expected");
  if (ErrorCode == 4063) return ("Integer parameter expected");
  if (ErrorCode == 4064) return ("Double parameter expected");
  if (ErrorCode == 4065) return ("Array as parameter expected");
  if (ErrorCode == 4066) return ("Requested history data in updating state");
  if (ErrorCode == 4067) return ("Some error in trading function");
  if (ErrorCode == 4099) return ("End of file");
  if (ErrorCode == 4100) return ("Some file error");
  if (ErrorCode == 4101) return ("Wrong file name");
  if (ErrorCode == 4102) return ("Too many opened files");
  if (ErrorCode == 4103) return ("Cannot open file");
  if (ErrorCode == 4104) return ("Incompatible access to a file");
  if (ErrorCode == 4105) return ("No order selected");
  if (ErrorCode == 4106) return ("Unknown symbol");
  if (ErrorCode == 4107) return ("Invalid price");
  if (ErrorCode == 4108) return ("Invalid ticket");
  if (ErrorCode == 4109) return ("Trade is not allowed. Enable checkbox \"Allow live trading\" in the expert properties");
  if (ErrorCode == 4110) return ("Longs are not allowed. Check the expert properties");
  if (ErrorCode == 4111) return ("Shorts are not allowed. Check the expert properties");
  if (ErrorCode == 4200) return ("Object exists already");
  if (ErrorCode == 4201) return ("Unknown object property");
  if (ErrorCode == 4202) return ("Object does not exist");
  if (ErrorCode == 4203) return ("Unknown object type");
  if (ErrorCode == 4204) return ("No object name");
  if (ErrorCode == 4205) return ("Object coordinates error");
  if (ErrorCode == 4206) return ("No specified subwindow");
  if (ErrorCode == 4207) return ("Some error in object function");
  return ("Not a known error code");
}

//--------------------------------------------------------------------

string GetUninitReasonDescription (int ReasonCode)
{
  if (ReasonCode == 0) return ("Script finished its execution independently");
  if (ReasonCode == 1) return ("Expert removed from chart");
  if (ReasonCode == 2) return ("Expert recompiled");
  if (ReasonCode == 3) return ("Symbol or timeframe changed on the chart");
  if (ReasonCode == 4) return ("Chart closed");
  if (ReasonCode == 5) return ("Inputs parameters was changed by user");
  if (ReasonCode == 6) return ("Other account activated");
  return ("Code not recognized");
}

//--------------------------------------------------------------------

void ErrorHandler (string Msg)
{
  LogMsg ("----");
  LogMsg (Msg);
  Print (Msg);
  Alert (Msg);
  Comment (Msg);
  PlaySound ("stops.wav");
  errmsg = Msg;
}

//--------------------------------------------------------------------

double nd (double Value, int Dig)
{
  return (NormalizeDouble(Value,Dig));
}

//+------------------------------------------------------------------+

double ndd (double Value)
{
  return (NormalizeDouble(Value,8));
}

//+------------------------------------------------------------------+

double ndp (double Value)
{
  return (NormalizeDouble(Value,Digits));
}

//+------------------------------------------------------------------+

string dts (double Value, int dig)
{
  return (DoubleToStr(Value,dig));
}

//+------------------------------------------------------------------+

string dtsp (double Value)
{
  return (DoubleToStr(Value,Digits));
}

//+------------------------------------------------------------------+

int PeriodIndex (int Per)
{
   if (Per == 1) return (1);
   else if (Per == 5) return (2);
   else if (Per == 15) return (3);
   else if (Per == 30) return (4);
   else if (Per == 60) return (5);
   else if (Per == 240) return (6);
   else if (Per == 1440) return (7);
   else if (Per == 10080) return (8);
   else if (Per == 43200) return (9);
   else return (-1);
}

//+------------------------------------------------------------------+

int CalcMagicNumber (int Per)
{
   return (MagicNumber*10+PeriodIndex(Per));
}

//+------------------------------------------------------------------+

int IsOrderPresent (string Symb, int OpType, double Lots, double PriceValue, double StopLossValue, double TakeProfitValue, int MagicNum)
{
  int NOrd = OrdersTotal();
  int i;
  
  if (NOrd == 0)
    return (false);
     
  for (i=NOrd-1; i>=0; i--)
  {
    OrderSelect (i, SELECT_BY_POS, MODE_TRADES);

    if ((OrderSymbol()==Symb) && (OrderMagicNumber()==MagicNum) && (OrderType()==OpType)
       && (OrderLots()==Lots) && (OrderOpenPrice()==PriceValue) && (OrderStopLoss()==StopLossValue)
       && (OrderTakeProfit()==TakeProfitValue))     
    {
      return (OrderTicket());
    }
  }

  return (-1);
}

//--------------------------------------------------------------------

int OrderSendSafe (int OpType, double Lots, double Price, double StopLoss, double TakeProfit, int MagicNumber, string InsComment)
{
  tickstarttot = GetTickCount();
  
  LogMsg ("Try to safely send order now");
  
  int Ticket, ErrCode;
  bool bModRes;
  int ordersendslippage = 10;

  double PriceValue = ndp (Price);
  double StopLossValue = ndp (StopLoss);
  double TakeProfitValue = ndp (TakeProfit);
  double LotsValue = nd(Lots,2);
  
  double DesiredPrice = ndp (Price);
  double ActualPrice;
  
  double StopLossDist;
  double TakeProfitDist;
  
  if (ndp(StopLossValue) == ndp(0.0)) 
    StopLossDist = ndp(0.0); 
  else
    StopLossDist = ndp(MathAbs(PriceValue-StopLossValue)); 
  
  if (ndp(TakeProfitValue) == ndp(0.0)) 
    TakeProfitDist = ndp(0.0); 
  else
    TakeProfitDist = ndp(MathAbs(PriceValue-TakeProfitValue)); 
  
  int Slippage;
  
  if (Digits==5 || Digits==3)
    Slippage = ordersendslippage*10;
  else 
    Slippage = ordersendslippage;

  if (OpType == OP_BUY)
    LogMsg ("Try to send buy open order, "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
  else if (OpType == OP_SELL)
    LogMsg ("Try to send sell open order, "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
  else if (OpType == OP_BUYSTOP)
    LogMsg ("Try to send buy stop order, "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
  else if (OpType == OP_SELLSTOP)
    LogMsg ("Try to send sell stop order, "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
  else if (OpType == OP_BUYLIMIT)
    LogMsg ("Try to send buy limit order, "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
  else if (OpType == OP_SELLLIMIT)
    LogMsg ("Try to send sell limit order, "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));

  if (LotsValue < MarketInfo(Symbol(),MODE_MINLOT))
  {
    LotsValue = MarketInfo(Symbol(),MODE_MINLOT);
    LogMsg ("Lots value too low, adjusting value to min allowed "+nd(LotsValue,2));
  }
  else if (LotsValue > MarketInfo(Symbol(),MODE_MAXLOT))
  {
    LotsValue = MarketInfo(Symbol(),MODE_MAXLOT);
    LogMsg ("Lots value too high, adjusting value to max allowed "+nd(LotsValue,2));
  }

  color Col;
  if (OpType==OP_BUY || OpType==OP_BUYSTOP || OpType==OP_BUYLIMIT) Col = Green;
  else if (OpType==OP_SELL || OpType==OP_SELLSTOP || OpType==OP_SELLLIMIT) Col = Red;
  else Col = Blue;
    
  bool OrderOk = false;
  bool LeaveLoop = false;
  
  while (! LeaveLoop)
  {
    LogMsg ("Starting order send safe, part 1");
    
    if ((OpType == OP_BUY) && (ndp(PriceValue) != ndp(Ask)))
    {
      PriceValue = ndp(Ask);
      LogMsg ("Buy open order, moving entry price to Ask "+dtsp(PriceValue));
    }
    else if ((OpType == OP_SELL) && (ndp(PriceValue) != ndp(Bid)))
    {
      PriceValue = ndp(Bid);
      LogMsg ("Sell open order, moving entry price to Bid "+dtsp(PriceValue));
    }
    else if (OpType == OP_BUYSTOP)
    {  
      if (ndp(PriceValue-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) < ndp(Ask))
      {
        PriceValue = ndp (Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point+1*pip);
        LogMsg ("Price too near to ask, moving entry price to "+dtsp(PriceValue));//nice!!
      }
    }
    else if (OpType == OP_SELLSTOP)
    {
      if (ndp(PriceValue+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) > ndp(Bid))
      {
        PriceValue = ndp (Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point-1*pip);
        LogMsg ("Price too near to bid, moving entry price to "+dtsp(PriceValue));//nice!!
      }
    }
    else if (OpType == OP_BUYLIMIT)
    {  
      if (ndp(PriceValue+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) > ndp(Bid))
      {
        PriceValue = ndp (Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point-1*pip);
        LogMsg ("Price too near to bid, moving entry price to "+dtsp(PriceValue));
      }
    }
    else if (OpType == OP_SELLLIMIT)
    {
      if (ndp(PriceValue-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) < ndp(Ask))
      {
        PriceValue = ndp (Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point+1*pip);
        LogMsg ("Price too near to ask, moving entry price to "+dtsp(PriceValue));
      }
    }
    
    tickstart = GetTickCount();
    Ticket = OrderSend (Symbol(), OpType, LotsValue, PriceValue, Slippage, ndp(0.0), ndp(0.0), (InsComment+" "+Symbol()), MagicNumber, 0, Col);
    tickstop = GetTickCount();
    LogMsg("OrderSend time " +(tickstop-tickstart)+ "ms");
    
    if (Ticket < 0)
    {
      ErrCode = GetLastError();
      
      if (ErrCode == 146)
      {
        LogMsg ("Trade context busy, waiting 1 second...");//br0ker problem with mt4
        Sleep (1000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 136)
      {
        LogMsg ("Off quotes error, waiting 5 seconds...");
        Sleep (5000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 128)
      {
        LogMsg ("Trade timeout (dangerous), refresh rates immediately...");
        //Sleep (30000);
        //LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 129)
      {
        LogMsg ("Invalid price, refresh rates immediately...");
        RefreshRates();
        
         if (OpType == OP_BUY)
           PriceValue = ndp (Ask);
         else if (OpType == OP_SELL)// hope this works, very important, 
           PriceValue = ndp (Bid);
         else
         {
           LogMsg ("Invalid condition");
           return (-1);
         }
         
         LogMsg ("New market price "+dtsp(PriceValue));
      }
      else if (ErrCode == 132)
      {
        LogMsg ("Market closed, waiting 30 seconds...");
        Sleep (30000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 138)
      {
        LogMsg ("Requoted from broker, refresh rates immediately...");
        RefreshRates();
      }
      else if (ErrCode == 6)
      {
        LogMsg ("No connection with trade server, waiting 1 second...");
        Sleep (1000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 2)
      {
        LogMsg ("Common error. All attempts to trade must be stopped until reasons are clarified. Restart of operation system and client terminal will possibly be needed.");
        LogMsg ("Instead, try to repeat operation (very dangerous), waiting 10 seconds...");
        Sleep (10000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 4107)
      {
        LogMsg ("Invalid price");
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 1)
      {
        LogMsg ("No error returned but the result is unknown (dangerous), waiting 2 seconds...");
        Sleep (2000);//also nice
        LogMsg ("Refresh rates...");
        RefreshRates();
        LogMsg ("Verify order presence...");
        
        Ticket = IsOrderPresent (Symbol(), OpType, LotsValue, PriceValue, 0.0, 0.0, MagicNumber);
        
        if (Ticket > 0)
        {
          LogMsg ("Order found, continue");
          OrderOk = true;
          LeaveLoop = true;
        }
        else
        {
          LogMsg ("Order not found, try to resend");
        }
      }
      else
      {
        LogMsg ("Error code not managed in order safe send part 1, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+")");
        
        if (ErrCode == 134)
        {
          LogMsg ("Not enough money in the account for this order");// boo hoo
        }
          
        LeaveLoop = true;
      }
    }
    else
    {
      LogMsg ("Order send safe part 1, order correctly sent");
      OrderSelect (Ticket, SELECT_BY_TICKET, MODE_TRADES);
      PriceValue = OrderOpenPrice();
      ActualPrice = ndp (PriceValue);
      
      if (OpType == OP_BUY)
        LogMsg ("Desired open price: " +dtsp(DesiredPrice)+ ", actual open price: " +dtsp(ActualPrice)+ ", slippage " +dts((ActualPrice-DesiredPrice)/pip,1)+ " pips");
      else if (OpType == OP_SELL)
        LogMsg ("Desired open price: " +dtsp(DesiredPrice)+ ", actual open price: " +dtsp(ActualPrice)+ ", slippage " +dts((-ActualPrice+DesiredPrice)/pip,1)+ " pips");
      
      OrderOk = true;
      LeaveLoop = true;
    }
  }

  if ((StopLossValue!=0.0 || TakeProfitValue!=0.0) && (OrderOk==true))
  {
    OrderOk = false;
    LeaveLoop = false;

    while (! LeaveLoop)
    {
      LogMsg ("Starting order send safe, part 2");

      if (ndp(StopLossValue) != ndp(0.0))
      {
        if ((OpType==OP_BUY || OpType==OP_BUYSTOP || OpType==OP_BUYLIMIT) && (ndp(StopLossValue)!=ndp(PriceValue-StopLossDist)))
        {
          StopLossValue = ndp (PriceValue-StopLossDist);
          LogMsg ("Moving stop loss according to the new open value to "+dtsp(StopLossValue));
        }
        else if ((OpType==OP_SELL || OpType==OP_SELLSTOP || OpType==OP_SELLLIMIT) && (ndp(StopLossValue)!=ndp(PriceValue+StopLossDist)))
        {
          StopLossValue = ndp (PriceValue+StopLossDist);
          LogMsg ("Moving stop loss according to the new open value to "+dtsp(StopLossValue));
        }
      }
      
      if (ndp(TakeProfitValue) != ndp(0.0))
      {
        if ((OpType==OP_BUY || OpType==OP_BUYSTOP || OpType==OP_BUYLIMIT) && (ndp(TakeProfitValue)!=ndp(PriceValue+TakeProfitDist)))
        {
          TakeProfitValue = ndp (PriceValue+TakeProfitDist);
          LogMsg ("Moving take profit according to the new open value to "+dtsp(TakeProfitValue));
        }
        else if ((OpType==OP_SELL || OpType==OP_SELLSTOP || OpType==OP_SELLLIMIT) && (ndp(TakeProfitValue)!=ndp(PriceValue-TakeProfitDist)))
        {
          TakeProfitValue = ndp (PriceValue-TakeProfitDist);
          LogMsg ("Moving take profit according to the new open value to "+dtsp(TakeProfitValue));
        }
      }
      
      if (ndp(StopLossValue) != ndp(0.0))
      {
        if ((OpType==OP_BUY || OpType==OP_BUYSTOP || OpType==OP_BUYLIMIT) && ((PriceValue-StopLossValue)<MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
        {
          StopLossValue = ndp (PriceValue-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point);
          LogMsg ("Stop loss too near to open price, moving stop loss price to "+dtsp(StopLossValue));
        }
        else if ((OpType==OP_SELL || OpType==OP_SELLSTOP || OpType==OP_SELLLIMIT) && ((-PriceValue+StopLossValue)<MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
        {
          StopLossValue = ndp (PriceValue+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point);
          LogMsg ("Stop loss too near to open price, moving stop loss price to "+dtsp(StopLossValue));
        }
      }

      if (ndp(TakeProfitValue) != ndp(0.0))
      {
        if ((OpType==OP_BUY || OpType==OP_BUYSTOP || OpType==OP_BUYLIMIT) && ((-PriceValue+TakeProfitValue)<MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
        {
          TakeProfitValue = ndp (PriceValue+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point);
          LogMsg ("Take profit too near to open price, moving take profit price to "+dtsp(TakeProfitValue));
        }
        else if ((OpType==OP_SELL || OpType==OP_SELLSTOP || OpType==OP_SELLLIMIT) && ((PriceValue-TakeProfitValue)<MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
        {
          TakeProfitValue = ndp (PriceValue-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point);
          LogMsg ("Take profit too near to open price, moving take profit price to "+dtsp(TakeProfitValue));
        }
      }

      LogMsg ("Trying to add stop loss ("+dtsp(StopLossValue)+") and take profit ("+dtsp(TakeProfitValue)+"), Bid "+dtsp(Bid)+", Ask "+dtsp(Ask));
      tickstart = GetTickCount();
      bModRes = OrderModify (Ticket, PriceValue, StopLossValue, TakeProfitValue, 0);
      tickstop = GetTickCount();
      LogMsg("OrderModify time " +(tickstop-tickstart)+ "ms");
  
      if (bModRes == false)
      {
        ErrCode = GetLastError();
      
        if (ErrCode == 146)
        {
          LogMsg ("Trade context busy, waiting 1 second...");
          Sleep (1000);
          LogMsg ("Refresh rates...");
          RefreshRates();
        }
        else if (ErrCode == 136)
        {
          LogMsg ("Off quotes error, waiting 5 seconds...");
          Sleep (5000);
          LogMsg ("Refresh rates...");
          RefreshRates();
        }
        else if (ErrCode == 128)
        {
          LogMsg ("Trade timeout (dangerous), refresh rates immediately...");
          //Sleep (30000);
          //LogMsg ("Refresh rates...");
          RefreshRates();
        }
        else if (ErrCode == 132)
        {
          LogMsg ("Market closed, waiting 30 seconds...");
          Sleep (30000);
          LogMsg ("Refresh rates...");
          RefreshRates();
        }
        else if (ErrCode == 138)
        {
          LogMsg ("Requoted from broker, refresh rates immediately...");
          LogMsg ("Refresh rates...");
          RefreshRates();
        }
        else if (ErrCode == 6)
        {
          LogMsg ("No connection with trade server, waiting 1 second...");
          Sleep (1000);
          LogMsg ("Refresh rates...");
          RefreshRates();
        }
        else if (ErrCode == 2)
        {
          LogMsg ("Common error. All attempts to trade must be stopped until reasons are clarified. Restart of operation system and client terminal will possibly be needed.");
          LogMsg ("Instead, try to repeat operation (very dangerous), waiting 10 seconds...");
          Sleep (10000);
          LogMsg ("Refresh rates...");
          RefreshRates();
        }
        else if (ErrCode == 130)
        {
          LogMsg ("Invalid stops, refresh rates immediately...");
          LogMsg ("Refresh rates...");
          RefreshRates();
        }
        else if (ErrCode == 1)
        {
          LogMsg ("No error returned but the result is unknown (dangerous), waiting 2 seconds...");
          Sleep (2000);
          LogMsg ("Refresh rates...");
          RefreshRates();
          LogMsg ("Verify order presence...");
        
          Ticket = IsOrderPresent (Symbol(), OpType, LotsValue, PriceValue, StopLossValue, TakeProfitValue, MagicNumber);
        
          if (Ticket > 0)
          {
            LogMsg ("Order found, continue");
            OrderOk = true;
            LeaveLoop = true;
          }
          else
          {
            LogMsg ("Order not found, try to resend");
          }
        }
        else
        {
          LogMsg ("Error code not managed in order safe send part 2, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+")");
          LeaveLoop = true;
        }
      }
      else
      {
        LogMsg ("Order send safe part 2, stop loss and/or take profit added successfully");
        OrderOk = true;
        LeaveLoop = true;
      }
    }
  }

  tickstoptot = GetTickCount();
  LogMsg("OrderSendSafe total time " +(tickstoptot-tickstarttot)+ "ms");
  
  if (OpType == OP_BUY)
  {
    if (OrderOk != true)
    {
      ErrorHandler ("Error in buy open order, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+"), "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
      return (-1);
    }
    else
    {
      LogMsg ("Buy open order #"+Ticket+" executed correctly, "+OrderStringTicket(Ticket));
      return (Ticket);
    }
  }

  if (OpType == OP_SELL)
  {
    if (OrderOk != true)
    {
      ErrorHandler ("Error in sell open order, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+"), "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
      return (-1);
    }
    else
    {
      LogMsg ("Sell open order #"+Ticket+" executed correctly, "+OrderStringTicket(Ticket));
      return (Ticket);
    }
  }

  if (OpType == OP_BUYSTOP)
  {
    if (OrderOk != true)
    {
      ErrorHandler ("Error in buy stop order send, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+"), "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
      return (-1);
    }
    else
    {
      LogMsg ("Buy stop order #"+Ticket+" correctly sent, "+OrderStringTicket(Ticket));
      return (Ticket);
    }
  }

  if (OpType == OP_SELLSTOP)
  {
    if (OrderOk != true)
    {
      ErrorHandler ("Error in sell stop order send, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+"), "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
      return (-1);
    }
    else
    {
      LogMsg ("Sell stop order #"+Ticket+" correctly sent, "+OrderStringTicket(Ticket));
      return (Ticket);
    }
  }

  if (OpType == OP_BUYLIMIT)
  {
    if (OrderOk != true)
    {
      ErrorHandler ("Error in buy limit order send, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+"), "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
      return (-1);
    }
    else
    {
      LogMsg ("Buy limit order #"+Ticket+" correctly sent, "+OrderStringTicket(Ticket));
      return (Ticket);
    }
  }

  if (OpType == OP_SELLLIMIT)
  {
    if (OrderOk != true)
    {
      ErrorHandler ("Error in sell limit order send, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+"), "+OrderString(LotsValue,PriceValue,StopLossValue,TakeProfitValue));
      return (-1);
    }
    else
    {
      LogMsg ("Sell limit order #"+Ticket+" correctly sent, "+OrderStringTicket(Ticket));
      return (Ticket);
    }
  }

  return (-1);
}

//--------------------------------------------------------------------

bool OrderCloseSafe (int Ticket, double Lots, double Price)
{
  tickstarttot = GetTickCount();
  
  double PriceVal = ndp(Price);
  double LotsVal = nd(Lots,2);
  bool RetVal;
  int ordersendslippage = 10;
  int Type, ErrCode;
  
  double DesiredPrice = ndp(Price);
  double ActualPrice;

  LogMsg ("Try to close order #"+Ticket+", lots "+dts(LotsVal,2)+", price "+dtsp(PriceVal)+" (bid "+dtsp(Bid)+", ask "+dtsp(Ask)+")");
  LogMsg ("Order data: "+OrderStringTicket(Ticket));
  
  int Slippage;
  
  if (Digits==5 || Digits==3)
    Slippage = ordersendslippage*10;
  else 
    Slippage = ordersendslippage;
    
  if (! OrderSelect (Ticket, SELECT_BY_TICKET))
  {
    ErrorHandler ("Invalid ticket in order close, ticket #"+Ticket);
    return (false);
  }

  Type = OrderType();
  
  if ((Type!=OP_BUY) && (Type!=OP_SELL))
  {
    ErrorHandler ("Invalid order type in order close");
    return (false);
  }
  
  bool OrderOk = false;
  
  color Col;
  if (Type==OP_BUY || Type==OP_BUYSTOP || Type==OP_BUYLIMIT) Col = Green;
  else if (Type==OP_SELL || Type==OP_SELLSTOP || Type==OP_SELLLIMIT) Col = Red;
  else Col = Blue;

  while (! OrderOk)
  {
    tickstart = GetTickCount();
    RetVal = OrderClose (Ticket, LotsVal, PriceVal, Slippage, Col);
    tickstop = GetTickCount();
    LogMsg("OrderClose time " +(tickstop-tickstart)+ "ms");
    
    if (RetVal != true)
    {
      ErrCode = GetLastError();
      
      if (ErrCode == 128)
      {
        LogMsg ("Trade timeout (dangerous), refresh rates immediately...");
        //Sleep (5000);
        //LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 129)
      {
        LogMsg ("Invalid price, refresh rates immediately...");
        RefreshRates();
        
         if (Type == OP_BUY)
           PriceVal = ndp (Bid);
         else if (Type == OP_SELL)
           PriceVal = ndp (Ask);
         else
         {
           LogMsg ("Invalid condition");
           return (false);
         }
         
         LogMsg ("New market price "+dtsp(PriceVal));
      }
      else if (ErrCode == 132)
      {
        LogMsg ("Market closed, waiting 30 seconds...");
        Sleep (30000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 136)
      {
        LogMsg ("Off quotes error, waiting 5 seconds...");
        Sleep (5000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 138)
      {
        LogMsg ("Requoted from broker, refresh rates immediately...");
        RefreshRates();
      }
      else if (ErrCode == 146)
      {
        LogMsg ("Trade context busy, waiting 1 second...");
        Sleep (1000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 6)
      {
        LogMsg ("No connection with trade server, waiting 1 second...");
        Sleep (1000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else if (ErrCode == 2)
      {
        LogMsg ("Common error. All attempts to trade must be stopped until reasons are clarified. Restart of operation system and client terminal will possibly be needed.");
        LogMsg ("Instead, try to repeat operation (very dangerous), waiting 10 seconds...");
        Sleep (10000);
        LogMsg ("Refresh rates...");
        RefreshRates();
      }
      else
      {
        ErrorHandler ("Error in order close, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+")");
        return (false);
      }
    }
    else
    {
      OrderOk = true;
    }
  }

  OrderSelect (Ticket, SELECT_BY_TICKET);
  ActualPrice = OrderClosePrice();
  
  if (Type == OP_BUY)
  {
    LogMsg ("Buy open order #"+Ticket+" correctly closed, lots "+dts(LotsVal,2)+", price "+dtsp(PriceVal)+", profit "+dts(OrderProfit(),2)+", swap "+dts(OrderSwap(),2));
    LogMsg ("Desired close price: " +dtsp(DesiredPrice)+ ", actual open price " +dtsp(ActualPrice)+ ", slippage " +dts((-ActualPrice+DesiredPrice)/pip,1)+ " pips");
  }  
  else if (Type == OP_SELL)
  {
    LogMsg ("Sell open order #"+Ticket+" correctly closed, lots "+dts(LotsVal,2)+", price "+dtsp(PriceVal)+", profit "+dts(OrderProfit(),2)+", swap "+dts(OrderSwap(),2));
    LogMsg ("Desired close price " +dtsp(DesiredPrice)+ ", actual open price " +dtsp(ActualPrice)+ ", slippage " +dts((ActualPrice-DesiredPrice)/pip,1)+ " pips");
  }

  tickstoptot = GetTickCount();
  LogMsg("OrderCloseSafe total time " +(tickstoptot-tickstarttot)+ "ms");
  return (true);
}

//--------------------------------------------------------------------

bool OrderModifySafe (int Ticket, double Price, double StopLoss, double TakeProfit)
{
  tickstarttot = GetTickCount();
  
  double PriceVal = ndp (Price);
  double StopLossVal = ndp (StopLoss);
  double TakeProfitVal = ndp (TakeProfit);
  bool RetVal;
  int Type, ErrCode;
  
  if (! OrderSelect (Ticket, SELECT_BY_TICKET))
  {
    ErrorHandler ("Invalid ticket in order close, ticket #"+Ticket);
    return (false);
  }
  
  double LotsVal = nd(OrderLots(),2);
  Type = OrderType();

  LogMsg ("Try to modify order #"+Ticket+", price "+dtsp(PriceVal)+", stop loss "+dtsp(StopLossVal)+", take profit "+dtsp(TakeProfitVal)+" (Bid "+dtsp(Bid)+", Ask "+dtsp(Ask)+")");

  while (true)
  {
    if ((Type==OP_BUY || Type==OP_SELL) && PriceVal!=ndp(OrderOpenPrice()))
    {
      PriceVal = ndp(OrderOpenPrice());
      LogMsg ("Price different to open price, move modification price to open price");
    }
    else if ((Type==OP_BUYSTOP || Type==OP_SELLLIMIT) && PriceVal<ndp(Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
    {
      PriceVal = ndp(Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point+1*pip);
      LogMsg ("Price too low, move to nearest allowed value " + dtsp(PriceVal));
    }
    else if ((Type==OP_SELLSTOP || Type==OP_BUYLIMIT) && PriceVal>ndp(Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
    {
      PriceVal = ndp(Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point-1*pip);
      LogMsg ("Price too high, move to nearest allowed value " + dtsp(PriceVal));
    }

    if (Type == OP_BUY)
    {
      if (StopLossVal!=0.0 && (Bid-StopLossVal) < MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      {
        StopLossVal = ndp(Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point-1*pip);
        LogMsg ("Stop too near to current price, move stop to nearest allowed value "+dtsp(StopLossVal));
      }
      
      if (TakeProfitVal!=0.0 && (-Ask+TakeProfitVal) < MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      {
        TakeProfitVal = ndp(Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point+1*pip);
        LogMsg ("Take profit too near to current price, move take profit to nearest allowed value "+dtsp(TakeProfitVal));
      }
    }
    else if (Type == OP_SELL)
    {
      if (StopLossVal!=0.0 && (-Ask+StopLossVal) < MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      {
        StopLossVal = ndp(Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point+1*pip);
        LogMsg ("Stop too near to current price, move stop to nearest allowed value "+dtsp(StopLossVal));
      }
      
      if (TakeProfitVal!=0.0 && (Bid-TakeProfitVal) < MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      {
        TakeProfitVal = ndp(Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point-1*pip);
        LogMsg ("Take profit too near to current price, move take profit to nearest allowed value "+dtsp(TakeProfitVal));
      }
    }
    else if (Type==OP_BUYSTOP || Type==OP_BUYLIMIT)
    {
      if (StopLossVal!=0.0 && (PriceVal-StopLossVal) < MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      {
        StopLossVal = ndp(PriceVal-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point-1*pip);
        LogMsg ("Stop too near to open price, move stop to nearest allowed value "+dtsp(StopLossVal));
      }
      
      if (TakeProfitVal!=0.0 && (-PriceVal+TakeProfitVal) < MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      {
        TakeProfitVal = ndp(PriceVal+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point+1*pip);
        LogMsg ("Take profit too near to open price, move take profit to nearest allowed value "+dtsp(TakeProfitVal));
      }
    }
    else if (Type==OP_SELLSTOP || Type==OP_SELLLIMIT)
    {
      if (StopLossVal!=0.0 && (-PriceVal+StopLossVal) < MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      {
        StopLossVal = ndp(PriceVal+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point+1*pip);
        LogMsg ("Stop too near to open price, move stop to nearest allowed value "+dtsp(StopLossVal));
      }
      
      if (TakeProfitVal!=0.0 && (PriceVal-TakeProfitVal) < MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      {
        TakeProfitVal = ndp(PriceVal-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point-1*pip);
        LogMsg ("Take profit too near to open price, move take profit to nearest allowed value "+dtsp(TakeProfitVal));
      }
    }

    if (ndp(OrderStopLoss())==ndp(StopLossVal) && ndp(OrderTakeProfit())==ndp(TakeProfitVal) && ndp(OrderOpenPrice())==ndp(PriceVal))
    {
      LogMsg ("Target order values are the same as current values, do nothing but consider order modification as successful");
    }
    else
    {
      tickstart = GetTickCount();
      RetVal = OrderModify (Ticket, PriceVal, StopLossVal, TakeProfitVal, 0);
      tickstop = GetTickCount();
      LogMsg("OrderModify time " +(tickstop-tickstart)+ "ms");
  
      if (RetVal != true)
      {
        ErrCode = GetLastError();

        if (ErrCode == 130)
        {
          LogMsg ("Invalid stops, refresh rates immediately and recalculate stops...");
          RefreshRates();
          continue;
        }
        else if (ErrCode == 128)
        {
          LogMsg ("Trade timeout (dangerous), refresh rates immediately...");
          //LogMsg ("Refresh rates...");
          RefreshRates();
          continue;
        }
        else if (ErrCode == 132)
        {
          LogMsg ("Market closed, waiting 30 seconds...");
          Sleep (30000);
          LogMsg ("Refresh rates...");
          RefreshRates();
          continue;
        }
        else if (ErrCode == 136)
        {
          LogMsg ("Off quotes error, waiting 5 seconds...");
          Sleep (5000);
          LogMsg ("Refresh rates...");
          RefreshRates();
          continue;
        }
        else if (ErrCode == 146)
        {
          LogMsg ("Trade context busy, waiting 1 second...");
          Sleep (1000);
          LogMsg ("Refresh rates...");
          RefreshRates();
          continue;
        }
        else if (ErrCode == 6)
        {
          LogMsg ("No connection with trade server, waiting 1 second...");
          Sleep (1000);
          LogMsg ("Refresh rates...");
          RefreshRates();
          continue;
        }
        else if (ErrCode == 2)
        {
          LogMsg ("Common error. All attempts to trade must be stopped until reasons are clarified. Restart of operation system and client terminal will possibly be needed.");
          LogMsg ("Instead, try to repeat operation (very dangerous), waiting 10 seconds...");
          Sleep (10000);
          LogMsg ("Refresh rates...");
          RefreshRates();
          continue;
        }
        else if (ErrCode == 1)
        {
          LogMsg ("No error returned but the result is unknown (dangerous), waiting 2 seconds...");
          LogMsg ("We suppose the order has not been modified, retry (dangerous)");
          Sleep (2000);
          LogMsg ("Refresh rates...");
          RefreshRates();
          continue;
        }
      
        ErrorHandler ("Error in order modify, error code " +ErrCode+ " (" +GetErrorCodeDescription(ErrCode)+"), Ticket "+Ticket+", PriceVal "+dtsp(PriceVal)+", StopLossVal "+dtsp(StopLossVal)+", TakeProfitVal "+dtsp(TakeProfitVal));
        return (false);
      }
    }

    if (Type == OP_BUY)
      LogMsg ("Buy open order #"+Ticket+" correctly modified, "+OrderStringTicket(Ticket));
    else if (Type == OP_SELL)
      LogMsg ("Sell open order #"+Ticket+" correctly modified, "+OrderStringTicket(Ticket));
    else if (Type == OP_BUYSTOP)
      LogMsg ("Buy stop order #"+Ticket+" correctly modified, "+OrderStringTicket(Ticket));
    else if (Type == OP_SELLSTOP)
      LogMsg ("Sell stop order #"+Ticket+" correctly modified, "+OrderStringTicket(Ticket));
    else if (Type == OP_BUYLIMIT)
      LogMsg ("Buy limit order #"+Ticket+" correctly modified, "+OrderStringTicket(Ticket));
    else if (Type == OP_SELLLIMIT)
      LogMsg ("Sell limit order #"+Ticket+" correctly modified, "+OrderStringTicket(Ticket));

    tickstoptot = GetTickCount();
    LogMsg("OrderModifySafe total time " +(tickstoptot-tickstarttot)+ "ms");
    return (true);
  }
}

//--------------------------------------------------------------------

bool NewBar (int TimeFrame)
{
   if (TimeFrame == 0)
      return (true);
   
   datetime tp = timeprev;
   datetime tc = TimeCurrent();
   
   if (TimeFrame == PERIOD_M1)
   {
      if (TimeMinute(tc) != TimeMinute(tp)) 
         return (true);
      else
         return (false);
   }

   if (TimeFrame == PERIOD_M5)
   {
      if ((TimeMinute(tc)!=TimeMinute(tp)) && ((TimeMinute(tc)%5)==0))
         return (true);
      else
         return (false);
   }

   if (TimeFrame == PERIOD_M15)
   {
      if ((TimeMinute(tc)!=TimeMinute(tp)) && ((TimeMinute(tc)%15)==0))
         return (true);
      else
         return (false);
   }

   if (TimeFrame == PERIOD_M30)
   {
      if ((TimeMinute(tc)!=TimeMinute(tp)) && ((TimeMinute(tc)%30)==0))
         return (true);
      else
         return (false);
   }

   if (TimeFrame == PERIOD_H1) 
   {
      if (TimeHour(tc) != TimeHour(tp))
         return (true);
      else
         return (false);
   }

   if (TimeFrame == PERIOD_H4)
   {
      if ((TimeHour(tc)!=TimeHour(tp)) && ((TimeHour(tc)%4)==0))
         return (true);
      else
         return (false);
   }

   if (TimeFrame == PERIOD_D1)
   {
      if (TimeDay(tc) != TimeDay(tp))
         return (true);
      else
         return (false);
   }

   if (TimeFrame == PERIOD_W1)
   {
      if ((TimeDay(tc)!=TimeDay(tp)) && (TimeDay(tp)==5))
         return (true);
      else
         return (false);
   }

   if (TimeFrame == PERIOD_MN1)
   {
      if ((TimeDay(tc)!=TimeDay(tp)) && (TimeDay(tc)==1))
         return (true);
      else
         return (false);
   }

   return (false);
}

//--------------------------------------------------------------------

bool TakeScreenShot (string filename, int sizex, int sizey, int startbar=-1, int chartscale=-1, int chartmode=-1)
{
  if (!IsTesting())
    WindowScreenShot (filename, sizex, sizey, startbar, chartscale, chartmode);
  
  return (true);
}

//--------------------------------------------------------------------

bool SaveVars ()
{
  LogMsg ("Save global variable lastspiketimeonentry " +TimeToStr(lastspiketimeonentry,TIME_DATE|TIME_MINUTES|TIME_SECONDS));
  GlobalVariableSet (EA_SHORT_NAME+"_"+Symbol()+"_"+CalcMagicNumber(period)+"_"+lastspiketimeonentry, lastspiketimeonentry);
  return (true);
}

//--------------------------------------------------------------------

bool LoadVars ()
{
  lastspiketimeonentry = GlobalVariableGet (EA_SHORT_NAME+"_"+Symbol()+"_"+CalcMagicNumber(period)+"_"+lastspiketimeonentry);
  LogMsg ("Reload global variable lastspiketimeonentry " +TimeToStr(lastspiketimeonentry,TIME_DATE|TIME_MINUTES|TIME_SECONDS));
  return (true);
}

//--------------------------------------------------------------------

int init()
{
   tickstarttot = GetTickCount();
  
   if (! IsTesting())
   {
      while (true)
      {
         Comment (TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES|TIME_SECONDS) + ", waiting for connection...");
      
         if (IsConnected())
         {
            Comment ("Successfully connected to broker server");
            break;
         }
      
         Sleep(2000);
         RefreshRates();
      }
   }
  
   if (Digits==4 || Digits==5) pip=0.0001;
   else if (Digits==2 || Digits==3) pip=0.01;
   if (PeriodIndex(TimeFrame) <=0) period = Period();
   else period = TimeFrame;
   latestbartimesignal = 0;
   timeprev = TimeCurrent();
   tickcount = 0;
   errmsg = "";
   
   InitLog();
   LogRestartString();
   LogAccountData();
   LogExternalParams();
   LoadVars();
  
   LogMsg (LOG_SEP);
   LogMsg ("Ts initialization");
   PrintInitComment();
   LogMsg ("Init completed correctly");
   GlobalVariableSet (EA_SHORT_NAME+"_"+CalcMagicNumber(period)+"_running", 1);
   return(0);
}

//+------------------------------------------------------------------+

int deinit()
{
   Comment ("");
   WriteDeInitToLog ();
   DeInitLog();
   GlobalVariableDel (EA_SHORT_NAME+"_"+CalcMagicNumber(period)+"_running");
   return(0);
}

//+------------------------------------------------------------------+

int start()
{
   string comm="";
   double retval;
   int currordercount;
   double netlot;
   datetime latestentrytime = 0;
   datetime timecurr = TimeCurrent();
   int extremeindex;
   int i;

   tickcount++;
   
   if (errmsg != "")
      return (-1);
   
   if (! GlobalVariableCheck(EA_SHORT_NAME+"_"+CalcMagicNumber(period)+"_running"))
      GlobalVariableSet (EA_SHORT_NAME+"_"+CalcMagicNumber(period)+"_running", 1);

   if (!IsTesting() || IsVisualMode())
   {
      comm = comm + EA_NAME_VERSION + " running\n";
      comm = comm + "Applied timeframe " + period + "\n";
      comm = comm + "Allowed dir " + AllowedDir + "\n";
      comm = comm + "Evaluation bar " + EvaluationBar + "\n";
      comm = comm + "Check only at end of bar " + CheckOnlyAtEndOfBar + "\n";
      comm = comm + "First bar confirmation " + FirstBarConfirmation + "\n";
      comm = comm + "Start extreme distance " + StartExtremeDist + "\n";
      comm = comm + "Max extreme distance " + MaxExtremeDist + "\n";
      comm = comm + "Stop loss pips " + dts(StopLossPips,1) + "\n";
      comm = comm + "Take profit pips " + dts(TakeProfitPips,1) + "\n";
      comm = comm + "Fixed lots " + dts(FixedLots,2) + "\n";
      comm = comm + "Allow multiple orders " + AllowMultipleOrders + "\n";
      //comm = comm + "Progressive bar signals " + ProgressiveBarSignals + "\n";
      //comm = comm + "Exit at extreme " + ExitAtExtreme + "\n";
      comm = comm + "Pip gain for breakeven stop trailing " + dts(PipGainForBreakevenStop,1) + "\n";
      //comm = comm + "Pip loss for breakeven target price " + dts(PipLossForBreakevenTarget,1) + "\n";
      comm = comm + "Monday hour start " +MondayHourStart+ "\n";
      comm = comm + "Use TMA filter " +UseTmaFilter+ "\n";
      comm = comm + "-----\n";
   }

   string ind;
   
   if (DisplayIndicators)
   {
      if (!IsTesting() || IsVisualMode())
      {
      
         ind = "Symphonie Extreme Indicator v2";
         //
         //retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
         //                  ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 0, EvaluationBar);
         //comm = comm + ind + " [" + ExtrPriceActionFilter + ", " + ExtrLength + ", " + ExtrMajorCycleStrength + ", " + ExtrUseCycleFilter + ", " + ExtrUseFilterSMAorRSI + ", " + ExtrFilterStrengthSMA 
         //            + ", " + ExtrFilterStrengthRSI + ", " + ExtrMinorAlert + ", " + ExtrMajorAlert + ", " + ExtrMajorGoneAlert + ", " + ExtrSoundAlert + ", " + ExtrEmailAlert + ", " + ExtrTrackMajorCycleHistory
         //            + ", " + ExtrWaitForClose + ", " + ExtrMajorGoneLookBackBars + /*", " + Extrnote1 + ", " + Extrnote2 + */", " + ExtralertsOption + "], buffer 0 LineBuffer: " + retval + "\n";
         //retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
         //                  ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 1, EvaluationBar);
         //comm = comm + ind + " [" + ExtrPriceActionFilter + ", " + ExtrLength + ", " + ExtrMajorCycleStrength + ", " + ExtrUseCycleFilter + ", " + ExtrUseFilterSMAorRSI + ", " + ExtrFilterStrengthSMA 
         //            + ", " + ExtrFilterStrengthRSI + ", " + ExtrMinorAlert + ", " + ExtrMajorAlert + ", " + ExtrMajorGoneAlert + ", " + ExtrSoundAlert + ", " + ExtrEmailAlert + ", " + ExtrTrackMajorCycleHistory
         //            + ", " + ExtrWaitForClose + ", " + ExtrMajorGoneLookBackBars + /*", " + Extrnote1 + ", " + Extrnote2 + */", " + ExtralertsOption + "], buffer 1 MajorCycleBuy: " + retval + "\n";
         //retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
         //                  ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 2, EvaluationBar);
         //comm = comm + ind + " [" + ExtrPriceActionFilter + ", " + ExtrLength + ", " + ExtrMajorCycleStrength + ", " + ExtrUseCycleFilter + ", " + ExtrUseFilterSMAorRSI + ", " + ExtrFilterStrengthSMA 
         //            + ", " + ExtrFilterStrengthRSI + ", " + ExtrMinorAlert + ", " + ExtrMajorAlert + ", " + ExtrMajorGoneAlert + ", " + ExtrSoundAlert + ", " + ExtrEmailAlert + ", " + ExtrTrackMajorCycleHistory
         //            + ", " + ExtrWaitForClose + ", " + ExtrMajorGoneLookBackBars + /*", " + Extrnote1 + ", " + Extrnote2 + */", " + ExtralertsOption + "], buffer 2 MajorCycleSell: " + retval + "\n";
         //retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
         //                  ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 3, EvaluationBar);
         //comm = comm + ind + " [" + ExtrPriceActionFilter + ", " + ExtrLength + ", " + ExtrMajorCycleStrength + ", " + ExtrUseCycleFilter + ", " + ExtrUseFilterSMAorRSI + ", " + ExtrFilterStrengthSMA 
         //            + ", " + ExtrFilterStrengthRSI + ", " + ExtrMinorAlert + ", " + ExtrMajorAlert + ", " + ExtrMajorGoneAlert + ", " + ExtrSoundAlert + ", " + ExtrEmailAlert + ", " + ExtrTrackMajorCycleHistory
         //            + ", " + ExtrWaitForClose + ", " + ExtrMajorGoneLookBackBars + /*", " + Extrnote1 + ", " + Extrnote2 + */", " + ExtralertsOption + "], buffer 3 MinorCycleBuy: " + retval + "\n";
         //retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
         //                  ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 4, EvaluationBar);
         //comm = comm + ind + " [" + ExtrPriceActionFilter + ", " + ExtrLength + ", " + ExtrMajorCycleStrength + ", " + ExtrUseCycleFilter + ", " + ExtrUseFilterSMAorRSI + ", " + ExtrFilterStrengthSMA 
         //            + ", " + ExtrFilterStrengthRSI + ", " + ExtrMinorAlert + ", " + ExtrMajorAlert + ", " + ExtrMajorGoneAlert + ", " + ExtrSoundAlert + ", " + ExtrEmailAlert + ", " + ExtrTrackMajorCycleHistory
         //            + ", " + ExtrWaitForClose + ", " + ExtrMajorGoneLookBackBars + /*", " + Extrnote1 + ", " + Extrnote2 + */", " + ExtralertsOption + "], buffer 4 MinorCycleSell: " + retval + "\n";
         //retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
         //                  ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 5, EvaluationBar);
         //comm = comm + ind + " [" + ExtrPriceActionFilter + ", " + ExtrLength + ", " + ExtrMajorCycleStrength + ", " + ExtrUseCycleFilter + ", " + ExtrUseFilterSMAorRSI + ", " + ExtrFilterStrengthSMA 
         //            + ", " + ExtrFilterStrengthRSI + ", " + ExtrMinorAlert + ", " + ExtrMajorAlert + ", " + ExtrMajorGoneAlert + ", " + ExtrSoundAlert + ", " + ExtrEmailAlert + ", " + ExtrTrackMajorCycleHistory
         //            + ", " + ExtrWaitForClose + ", " + ExtrMajorGoneLookBackBars + /*", " + Extrnote1 + ", " + Extrnote2 + */", " + ExtralertsOption + "], buffer 5 ZL1: " + retval + "\n";
         //retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
         //                  ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 6, EvaluationBar);
         //comm = comm + ind + " [" + ExtrPriceActionFilter + ", " + ExtrLength + ", " + ExtrMajorCycleStrength + ", " + ExtrUseCycleFilter + ", " + ExtrUseFilterSMAorRSI + ", " + ExtrFilterStrengthSMA 
         //            + ", " + ExtrFilterStrengthRSI + ", " + ExtrMinorAlert + ", " + ExtrMajorAlert + ", " + ExtrMajorGoneAlert + ", " + ExtrSoundAlert + ", " + ExtrEmailAlert + ", " + ExtrTrackMajorCycleHistory
         //            + ", " + ExtrWaitForClose + ", " + ExtrMajorGoneLookBackBars + /*", " + Extrnote1 + ", " + Extrnote2 + */", " + ExtralertsOption + "], buffer 6 MajorCycleBuyHistory: " + retval + "\n";
         //retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
         //                  ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 7, EvaluationBar);
         //comm = comm + ind + " [" + ExtrPriceActionFilter + ", " + ExtrLength + ", " + ExtrMajorCycleStrength + ", " + ExtrUseCycleFilter + ", " + ExtrUseFilterSMAorRSI + ", " + ExtrFilterStrengthSMA 
         //            + ", " + ExtrFilterStrengthRSI + ", " + ExtrMinorAlert + ", " + ExtrMajorAlert + ", " + ExtrMajorGoneAlert + ", " + ExtrSoundAlert + ", " + ExtrEmailAlert + ", " + ExtrTrackMajorCycleHistory
         //            + ", " + ExtrWaitForClose + ", " + ExtrMajorGoneLookBackBars + /*", " + Extrnote1 + ", " + Extrnote2 + */", " + ExtralertsOption + "], buffer 7 MajorCycleSellHistory: " + retval + "\n";
         
         comm = comm + "Buffer line: ";
         
         for (i=0; i<20; i++)
         {
            retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
                           ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 0, i);
            
            if (ndd(retval)==ndd(0))
               comm = comm + ". ";
            else
               comm = comm + i + ":" + dts(retval,2) + " ";
         }
         
         comm = comm + "\nMajor cycle buy: ";
         
         for (i=0; i<20; i++)
         {
            retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
                           ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 1, i);
            
            if (ndd(retval)==ndd(0))
               comm = comm + ". ";
            else
               comm = comm + i + ":" + dts(retval,2) + " ";
         }
         
         comm = comm + "\nMajor cycle sell: ";
         
         for (i=0; i<20; i++)
         {
            retval = iCustom (NULL, period, ind, ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, ExtrMinorAlert, ExtrMajorAlert, 
                           ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 2, i);
            
            if (ndd(retval)==ndd(0))
               comm = comm + ". ";
            else
               comm = comm + i + ":" + dts(retval,2) + " ";
         }

         comm = comm + "\n-----\n";
      }
   }
   
   int emotiondir = 0;
   ind = "Symphonie_Market_Emotion_Indikator";
   retval = iCustom (NULL, period, ind, MarketEmotionSSP, MarketEmotionKmax, MarketEmotionCountBars, 0, EvaluationBar);
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + ind + " [" + MarketEmotionSSP + ", " + MarketEmotionKmax + ", " + MarketEmotionCountBars + "], buffer 0 Blue: " + retval + "\n";
   if (ndd(retval) != ndd(0.0)) emotiondir=1;
   retval = iCustom (NULL, period, ind, MarketEmotionSSP, MarketEmotionKmax, MarketEmotionCountBars, 1, EvaluationBar);
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + ind + " [" + MarketEmotionSSP + ", " + MarketEmotionKmax + ", " + MarketEmotionCountBars + "], buffer 1 Red: " + retval + "\n";
   if (ndd(retval) != ndd(0.0)) emotiondir=-1;
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + "-----\n";

   int sentimentdir = 0;
   ind = "Symphonie_Sentiment_Indikator";
   retval = iCustom (NULL, period, ind, SentimentPeriod, 0, EvaluationBar);
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + ind + " [" + SentimentPeriod + "], buffer 0 Black: " + retval + "\n";
   retval = iCustom (NULL, period, ind, SentimentPeriod, 1, EvaluationBar);
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + ind + " [" + SentimentPeriod + "], buffer 1 Blue: " + retval + "\n";
   if (ndd(retval) != ndd(0.0)) sentimentdir=1;
   retval = iCustom (NULL, period, ind, SentimentPeriod, 2, EvaluationBar);
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + ind + " [" + SentimentPeriod + "], buffer 2 Red: " + retval + "\n";
   if (ndd(retval) != ndd(0.0)) sentimentdir=-1;
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + "-----\n";
   
   int trenddir = 0;
   ind = "Symphonie_Trendline_Indikator";
   retval = iCustom (NULL, period, ind, TrendlineCCIPeriod, TrendlineATRPeriod, 0, EvaluationBar);
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + ind + " [" + TrendlineCCIPeriod + ", " + TrendlineATRPeriod +"], buffer 0 TrendUp: " + retval + "\n";
   if (retval != EMPTY_VALUE) trenddir=1;
   retval = iCustom (NULL, period, ind, TrendlineCCIPeriod, TrendlineATRPeriod, 1, EvaluationBar);
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + ind + " [" + TrendlineCCIPeriod + ", " + TrendlineATRPeriod +"], buffer 1 TrendDown: " + retval + "\n";
   if (retval != EMPTY_VALUE) trenddir=-1;
   /*retval = iCustom (NULL, period, ind, TrendlineCCIPeriod, TrendlineATRPeriod, 2, EvaluationBar);
   if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + ind + " [" + TrendlineCCIPeriod + ", " + TrendlineATRPeriod +"], buffer 2: " + retval + "\n";
   retval = iCustom (NULL, period, ind, TrendlineCCIPeriod, TrendlineATRPeriod, 3, EvaluationBar);
   if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + ind + " [" + TrendlineCCIPeriod + ", " + TrendlineATRPeriod +"], buffer 3: " + retval + "\n";*/
   //if (DisplayIndicators && (!IsTesting() || IsVisualMode())) comm = comm + "-----\n";

   int extremedir = 0;
   
   for (i=StartExtremeDist; i<iBars(NULL,period); i++)
   {
      if (i > MaxExtremeDist)
         break;
      
      retval = iCustom (NULL, period, "Symphonie Extreme Indicator v2", ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, 
                        ExtrMinorAlert, ExtrMajorAlert, ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 1, i);
      
      if (ndd(retval) < ndd(0.0))
      {
         if (!ProgressiveBarSignals || iTime(Symbol(),period,i)>=latestbartimesignal)
         {
            extremedir = 1;
            extremeindex = i;
            latestbartimesignal = iTime (Symbol(), period, extremeindex);
            
            if (!IsTesting() || IsVisualMode())
            {
               comm = comm + "Extreme[" + extremeindex + "] is up: BUY";
               comm = comm + ", latest entry spike at " +TimeToStr(lastspiketimeonentry,TIME_DATE|TIME_MINUTES)+ ", current spike at " +TimeToStr(latestbartimesignal,TIME_DATE|TIME_MINUTES);
               if (ProgressiveBarSignals) comm = comm + "Latest bar time signal " +TimeToStr(latestbartimesignal,TIME_DATE|TIME_MINUTES|TIME_SECONDS)+ "\n";
               else comm = comm + "\n";
            }
            
            break;
         }
      }
      
      retval = iCustom (NULL, period, "Symphonie Extreme Indicator v2", ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, 
                        ExtrMinorAlert, ExtrMajorAlert, ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 2, i);
      
      if (ndd(retval) > ndd(0.0))
      {
         if (!ProgressiveBarSignals || iTime(Symbol(),period,i)>=latestbartimesignal)
         {
            extremedir = -1;
            extremeindex = i;
            latestbartimesignal = iTime (Symbol(), period, extremeindex);

            if (!IsTesting() || IsVisualMode())
            {
               comm = comm + "Extreme[" + extremeindex + "] is up: SELL";
               comm = comm + ", latest entry spike at " +TimeToStr(lastspiketimeonentry,TIME_DATE|TIME_MINUTES)+ ", current spike at " +TimeToStr(latestbartimesignal,TIME_DATE|TIME_MINUTES);
               if (ProgressiveBarSignals) comm = comm + "Latest bar time signal " +TimeToStr(latestbartimesignal,TIME_DATE|TIME_MINUTES|TIME_SECONDS)+ "\n";
               else comm = comm + "\n";
            }

            break;
         }
      }
   }
   
   int tmadir = 0;
   double tmapricecurr;
   double tmamiddleband;
   
   if (UseTmaFilter)
   {
      tmapricecurr = Bid;
      tmamiddleband = iCustom (NULL, period, "TMA", ""+period, TmaHalfLength, TmaPrice, TmaATRMultiplier, TmaATRPeriod, TmaInterpolate,
                               TmaAlertsOn, TmaAlertsOnCurrent, TmaAlertsOnHighLow, TmaAlertsMessage, TmaAlertsSound, TmaAlertsEmail, 0, 0);
      
      if (ndd(tmapricecurr) < ndd(tmamiddleband)) 
         tmadir = 1;
      else
         tmadir = -1;
   }
   
   if (!IsTesting() || IsVisualMode())
   {
      if (extremedir == 0) comm = comm + "Extreme is undefined: FLAT\n";
   
      if (emotiondir == 1) comm = comm + "Emotion is up: BUY\n";
      else if (emotiondir == -1) comm = comm + "Emotion is down: SELL\n";
      else comm = comm + "Emotion is undefined: FLAT\n";
   
      if (sentimentdir == 1) comm = comm + "Sentiment is up: BUY\n";
      else if (sentimentdir == -1) comm = comm + "Sentiment is down: SELL\n";
      else comm = comm + "Sentiment is undefined: FLAT\n";
   
      if (trenddir == 1) comm = comm + "Trend is up: BUY\n";
      else if (trenddir == -1) comm = comm + "Trend is down: SELL\n";
      else comm = comm + "Trend is undefined: FLAT\n";
      
      if (UseTmaFilter)
      {
         if (tmadir == 1) comm = comm + "TMA is " +dtsp(tmamiddleband)+ ", price " +dtsp(tmapricecurr)+ ": BUY\n";
         else if (tmadir == -1) comm = comm + "TMA is " +dtsp(tmamiddleband)+ ", price " +dtsp(tmapricecurr)+ ": SELL\n";
         else comm = comm + "TMA is " +dtsp(tmamiddleband)+ ", price " +dtsp(tmapricecurr)+ ": FLAT\n";
      }
      
      comm = comm + "-----\n";
   }
   
   if (!IsTesting() || IsVisualMode()) Comment (comm);
   
   currordercount = 0;
   netlot = 0.0;
   
   for (i=OrdersTotal()-1; i>=0; i--)
   {
      OrderSelect (i, SELECT_BY_POS, MODE_TRADES);
      
      if (OrderMagicNumber()==CalcMagicNumber(period) && OrderSymbol()==Symbol())
      {
         if (ExitAtExtreme)
         {
            if (OrderType() == OP_BUY)
            {
               //retval = iCustom (NULL, period, "Symphonie Extreme Indicator v2", ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, 
               //                  ExtrMinorAlert, ExtrMajorAlert, ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 2, EvaluationBar);
      
               //if (ndd(retval) > ndd(0.0))
               if (extremedir == -1)
               {
                  LogMsg (LOG_SEP);
                  LogMsg ("Reversal extreme found, close long order now");
                  
                  if (! OrderCloseSafe (OrderTicket(), OrderLots(), Bid))
                  {
                     Alert (EA_NAME_VERSION + " ERROR in OrderCloseSafe");
                     TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_CloseLong_"+TimeCurrent()+"_ERROR.gif", 800, 600);
                     return (-1);
                  }
                  
                  TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_CloseLong_"+TimeCurrent()+".gif", 800, 600);
                  continue;
               }
            }
            else if (OrderType() == OP_SELL)
            {
               //retval = iCustom (NULL, period, "Symphonie Extreme Indicator v2", ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, 
               //                  ExtrMinorAlert, ExtrMajorAlert, ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 1, EvaluationBar);
      
               //if (ndd(retval) < ndd(0.0))
               if (extremedir == 1)
               {
                  LogMsg (LOG_SEP);
                  LogMsg ("Reversal extreme found, close short order now");
                  
                  if (! OrderCloseSafe (OrderTicket(), OrderLots(), Ask))
                  {
                     Alert (EA_NAME_VERSION + " ERROR in OrderCloseSafe");
                     TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_CloseShort_"+TimeCurrent()+"_ERROR.gif", 800, 600);
                     return (-1);
                  }
                  
                  TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_CloseShort_"+TimeCurrent()+".gif", 800, 600);
                  continue;
               }
            }
         }

         if (OrderType() == OP_BUY)
         {
           if (ndd(OrderStopLoss())<ndd(OrderOpenPrice()) && ndd(Bid)>=(ndd(OrderOpenPrice()+PipGainForBreakevenStop*pip)))
           {
             LogMsg (LOG_SEP);
             LogMsg ("Trailing stop to breakeven");
                  
             if (! OrderModifySafe (OrderTicket(), OrderOpenPrice(), OrderOpenPrice()+3.0*pip, OrderTakeProfit()))
             {
               Alert (EA_NAME_VERSION + " ERROR in OrderModifySafe");
               TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_BreakevenTrailingLong_"+TimeCurrent()+"_ERROR.gif", 800, 600);
               return (-1);
             }
                  
             TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_BreakevenTrailingLong_"+TimeCurrent()+".gif", 800, 600);
           }
           
           if (ndd(OrderTakeProfit())>ndd(OrderOpenPrice()+5.0*pip) && ndd(Bid)<=(ndd(OrderOpenPrice()-PipLossForBreakevenTarget*pip)))
           {
             LogMsg (LOG_SEP);
             LogMsg ("Move target price to breakeven");
             
             if (! OrderModifySafe (OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderOpenPrice()+3.0*pip))
             {
               Alert (EA_NAME_VERSION + " ERROR in OrderModifySafe");
               TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_BreakevenTrailingTargetLong_"+TimeCurrent()+"_ERROR.gif", 800, 600);
               return (-1);
             }
                  
             TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_BreakevenTrailingTargetLong_"+TimeCurrent()+".gif", 800, 600);
           }
         }
         else if (OrderType() == OP_SELL)
         {
           if (ndd(OrderStopLoss())>ndd(OrderOpenPrice()) && ndd(Ask)<=(ndd(OrderOpenPrice()-PipGainForBreakevenStop*pip)))
           {
             LogMsg (LOG_SEP);
             LogMsg ("Trailing stop to breakeven");
         
             if (! OrderModifySafe (OrderTicket(), OrderOpenPrice(), OrderOpenPrice()-3.0*pip, OrderTakeProfit()))
             {
               Alert (EA_NAME_VERSION + " ERROR in OrderModifySafe");
               TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_BreakevenTrailingShort_"+TimeCurrent()+"_ERROR.gif", 800, 600);
               return (-1);
             }
                  
             TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_BreakevenTrailingShort_"+TimeCurrent()+".gif", 800, 600);
           }
           
           if (ndd(OrderTakeProfit())<ndd(OrderOpenPrice()-5.0*pip) && ndd(Ask)>=(ndd(OrderOpenPrice()+PipLossForBreakevenTarget*pip)))
           {
             LogMsg (LOG_SEP);
             LogMsg ("Move target price to breakeven");
             
             if (! OrderModifySafe (OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderOpenPrice()-3.0*pip))
             {
               Alert (EA_NAME_VERSION + " ERROR in OrderModifySafe");
               TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_BreakevenTrailingTargetShort_"+TimeCurrent()+"_ERROR.gif", 800, 600);
               return (-1);
             }
                  
             TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_BreakevenTrailingTargetShort_"+TimeCurrent()+".gif", 800, 600);
           }
         }
         
         if (!IsTesting() || IsVisualMode())
         {
           comm = comm + "Ticket #" + OrderTicket() + ", entry time " + TimeToStr(OrderOpenTime(),TIME_DATE|TIME_MINUTES|TIME_SECONDS) + "\n";
           
           if (OrderType()==OP_BUY)
             comm = comm + "  BUY, profit " +dts(OrderProfit(),2)+ ", pip gain " + dts((Bid-OrderOpenPrice())/pip,1) + "\n";
           else if (OrderType()==OP_SELL)
             comm = comm + "  SELL, profit " +dts(OrderProfit(),2)+ ", pip gain " + dts((-Ask+OrderOpenPrice())/pip,1) + "\n";
             
           if (OrderType()==OP_BUY && ndd(OrderStopLoss())>ndd(OrderOpenPrice()))
             comm = comm + "  Stop loss trailed at breakeven\n";
           else if (OrderType()==OP_SELL && ndd(OrderStopLoss())<ndd(OrderOpenPrice()))
             comm = comm + "  Stop loss trailed at breakeven\n";
             
           if (OrderType()==OP_BUY && ndd(OrderTakeProfit())<ndd(OrderOpenPrice()+5.0*pip))
             comm = comm + "  Take profit moved to breakeven\n";
           else if (OrderType()==OP_SELL && ndd(OrderTakeProfit())>ndd(OrderOpenPrice()-5.0*pip))
             comm = comm + "  Take profit moved to breakeven\n";
         }
          
         currordercount++;
         if (OrderType() == OP_BUY) netlot += OrderLots();
         else if (OrderType() == OP_SELL) netlot -= OrderLots();
        
         if (OrderOpenTime() > latestentrytime)
            latestentrytime = OrderOpenTime();
      }
   }
   
   if (!IsTesting() || IsVisualMode())
   {
      comm = comm + "Order count " + currordercount + ", net lots " +dts(netlot,2)+ "\n";
   
      if (currordercount == 0) 
         comm = comm + "LOOKING FOR ENTRY\n";
   }
   
   if (!IsTesting() || IsVisualMode()) Comment (comm);
   
   bool newbar = NewBar(period);
   
   if (newbar)
   {
      LogMsg (LOG_SEP);
      LogMsg ("New bar, extremedir " +extremedir+ ", emotiondir " +emotiondir+ ", sentimentdir " +sentimentdir+ ", trenddir " +trenddir);
   }
   
   if ((currordercount==0 || AllowMultipleOrders) && (newbar || !CheckOnlyAtEndOfBar))
   {
      int optype;
      double lots;
      double entryprice;
      double stoplossprice = 0.0;
      double takeprofitprice = 0.0;
      
      datetime currentextremetime;
      
      int extremedircurr;
      int emotiondircurr;
      int sentimentdircurr;
      int trenddircurr;
      
      if (FirstBarConfirmation)
      {
         extremedircurr = 0;
   
         for (i=0; i<StartExtremeDist; i++)
         {
            retval = iCustom (NULL, period, "Symphonie Extreme Indicator v2", ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, 
                        ExtrMinorAlert, ExtrMajorAlert, ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 1, i);
 
            if (ndd(retval) < ndd(0.0))
            {
               extremedircurr = 1;
               break;
            }
      
            retval = iCustom (NULL, period, "Symphonie Extreme Indicator v2", ExtrPriceActionFilter, ExtrLength, ExtrMajorCycleStrength, ExtrUseCycleFilter, ExtrUseFilterSMAorRSI, ExtrFilterStrengthSMA, ExtrFilterStrengthRSI, 
                        ExtrMinorAlert, ExtrMajorAlert, ExtrMajorGoneAlert, ExtrSoundAlert, ExtrEmailAlert, ExtrTrackMajorCycleHistory, ExtrWaitForClose, ExtrMajorGoneLookBackBars, Extrnote1, Extrnote2, ExtralertsOption, 2, i);
      
            if (ndd(retval) > ndd(0.0))
            {
               extremedircurr = -1;
               break;
            }
         }
         
         if (extremedircurr == 0)  extremedircurr=extremedir;

         emotiondircurr = 0;
         retval = iCustom (NULL, period, "Symphonie_Market_Emotion_Indikator", MarketEmotionSSP, MarketEmotionKmax, MarketEmotionCountBars, 0, 0);
         if (ndd(retval) != ndd(0.0)) emotiondircurr=1;
         retval = iCustom (NULL, period, "Symphonie_Market_Emotion_Indikator", MarketEmotionSSP, MarketEmotionKmax, MarketEmotionCountBars, 1, 0);
         if (ndd(retval) != ndd(0.0)) emotiondircurr=-1;
         
         sentimentdircurr = 0;
         retval = iCustom (NULL, period, "Symphonie_Sentiment_Indikator", SentimentPeriod, 1, 0);
         if (ndd(retval) != ndd(0.0)) sentimentdircurr=1;
         retval = iCustom (NULL, period, "Symphonie_Sentiment_Indikator", SentimentPeriod, 2, 0);
         if (ndd(retval) != ndd(0.0)) sentimentdircurr=-1;
   
         trenddircurr = 0;
         retval = iCustom (NULL, period, "Symphonie_Trendline_Indikator", TrendlineCCIPeriod, TrendlineATRPeriod, 0, 0);
         if (retval != EMPTY_VALUE) trenddircurr=1;
         retval = iCustom (NULL, period, "Symphonie_Trendline_Indikator", TrendlineCCIPeriod, TrendlineATRPeriod, 1, 0);
         if (retval != EMPTY_VALUE) trenddircurr=-1;
      }
      
      if (extremedir==1 && emotiondir==1 && sentimentdir==1 && trenddir==1 && AllowedDir>=0
          && (!FirstBarConfirmation || (extremedircurr==1 && emotiondircurr==1 && sentimentdircurr==1 && trenddircurr==1))
          && (MondayHourStart<0 || (!TimeDayOfWeek(TimeCurrent())==0 && !(TimeDayOfWeek(TimeCurrent())==1 && TimeHour(TimeCurrent())<MondayHourStart)))
          && (!UseTmaFilter || tmadir==1)
          )
      {
         currentextremetime = iTime (Symbol(), period, extremeindex);
            
         if (lastspiketimeonentry < currentextremetime)
         {
            LogMsg (LOG_SEP);
            LogMsg ("Open long position now");
            LogMsg ("   extremedir " +extremedir);
            LogMsg ("   emotiondir " +emotiondir);
            LogMsg ("   sentimentdir " +sentimentdir);
            LogMsg ("   trenddir " +trenddir);
            LogMsg ("   AllowedDir " +AllowedDir);
            
            if (FirstBarConfirmation)
            {
               LogMsg ("   extremedircurr " +extremedircurr);
               LogMsg ("   emotiondircurr " +emotiondircurr);
               LogMsg ("   sentimentdircurr " +sentimentdircurr);
               LogMsg ("   trenddircurr " +trenddircurr);
            }
            
            LogMsg ("   MondayHourStart " +MondayHourStart);

            if (UseTmaFilter)
            {
               LogMsg ("   tmadir " +tmadir);
               LogMsg ("   tmapricecurr " +tmapricecurr);
               LogMsg ("   tmamiddleband " +tmamiddleband);
            }
             
            optype = OP_BUY;
            lots = FixedLots;
            entryprice = ndp(Ask);
            
            if (ndd(StopLossPips) != ndd(0.0))
               stoplossprice = ndp(entryprice - StopLossPips*pip);

            if (ndd(TakeProfitPips) != ndd(0.0))
               takeprofitprice = ndp(entryprice + TakeProfitPips*pip);

            if (OrderSendSafe (optype, lots, entryprice, stoplossprice, takeprofitprice, CalcMagicNumber(period), EA_NAME_VERSION) <= 0)
            {
               Alert (EA_NAME_VERSION + " ERROR in OrderSendSafe");
               TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_OpenLong_"+TimeCurrent()+"_ERROR.gif", 800, 600);
               return (-1);
            }
            
            TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_OpenLong_"+TimeCurrent()+".gif", 800, 600);
            lastspiketimeonentry = currentextremetime;
            SaveVars();
         }
      }
      else if (extremedir==-1 && emotiondir==-1 && sentimentdir==-1 && trenddir==-1 && AllowedDir<=0
               && (!FirstBarConfirmation || (extremedircurr==-1 && emotiondircurr==-1 && sentimentdircurr==-1 && trenddircurr==-1))
               && (MondayHourStart<0 || (!TimeDayOfWeek(TimeCurrent())==0 && !(TimeDayOfWeek(TimeCurrent())==1 && TimeHour(TimeCurrent())<MondayHourStart)))
               && (!UseTmaFilter || tmadir==-1)
               )
      {
         currentextremetime = iTime (Symbol(), period, extremeindex);
            
         if (lastspiketimeonentry < currentextremetime)
         {
            LogMsg (LOG_SEP);
            LogMsg ("Open short position now");
            LogMsg ("   extremedir " +extremedir);
            LogMsg ("   emotiondir " +emotiondir);
            LogMsg ("   sentimentdir " +sentimentdir);
            LogMsg ("   trenddir " +trenddir);
            LogMsg ("   AllowedDir " +AllowedDir);
            
            if (FirstBarConfirmation)
            {
               LogMsg ("   extremedircurr " +extremedircurr);
               LogMsg ("   emotiondircurr " +emotiondircurr);
               LogMsg ("   sentimentdircurr " +sentimentdircurr);
               LogMsg ("   trenddircurr " +trenddircurr);
            }
            
            LogMsg ("   MondayHourStart " +MondayHourStart);

            if (UseTmaFilter)
            {
               LogMsg ("   tmadir " +tmadir);
               LogMsg ("   tmapricecurr " +tmapricecurr);
               LogMsg ("   tmamiddleband " +tmamiddleband);
            }
            
            optype = OP_SELL;
            lots = FixedLots;
            entryprice = ndp(Bid);
            
            if (ndd(StopLossPips) != ndd(0.0))
               stoplossprice = ndp(entryprice + StopLossPips*pip);
               
            if (ndd(TakeProfitPips) != ndd(0.0))
               takeprofitprice = ndp(entryprice - TakeProfitPips*pip);

            if (OrderSendSafe (optype, lots, entryprice, stoplossprice, takeprofitprice, CalcMagicNumber(period), EA_NAME_VERSION) <= 0)
            {
               Alert (EA_NAME_VERSION + " ERROR in OrderSendSafe");
               TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_OpenShort_"+TimeCurrent()+"_ERROR.gif", 800, 600);
               return (-1);
            }
            
            TakeScreenShot (EA_SHORT_NAME+"_"+Symbol()+"_"+period+"_OpenShort_"+TimeCurrent()+".gif", 800, 600);
            lastspiketimeonentry = currentextremetime;
            SaveVars();
         }
      }
   }
   
   timeprev = timecurr;
   return(0);
}

//+------------------------------------------------------------------+

// EOF
// brilliant work asasa.